import java.awt.*;
import java.lang.*;
import java.io.*;

	class Aire1Gui extends Frame {
		TextField a1,a2,a3,a4,a5,a6;
		Button c1,c2,c3;
		Label l1,l2,l3,l4,l5,l6;
		Aire1Calculs calcul = null ;
		String nom = "sensenom.dat";
		boolean plot = false;
		boolean eps = false;
		float hi = 100.0f;
		float hx = 80.0f;
		float v = 1.0f;
		float dt = 1.0f;
		int npart = 20;
		int max = 200;

		Aire1Gui(String windowTitle) {
			super(windowTitle);
		}

		public void init() {
			setLayout(new GridLayout(0,3,10,10));
			a1 = new TextField(Float.toString(hi));
			a2 = new TextField(Float.toString(hx));
			a3 = new TextField(Float.toString(v));
			a4 = new TextField(Float.toString(dt));
			a5 = new TextField(Integer.toString(npart));
			a6 = new TextField(Integer.toString(max));
			c1 = new Button("Calcular");
			c2 = new Button("Guardar");
			c3 = new Button("Sortir");
			l1 = new Label("Alc,ada de la inversio");
			l2 = new Label("Alc,ada de la xemeneia");
			l3 = new Label("Velocitat del vent");
			l4 = new Label("Pas de temps");
			l5 = new Label("Particules emeses");
			l6 = new Label("Passos simulats");
			add(l1);
			add(l2);
			add(l3);
			add(a1);
			add(a2);
			add(a3);
			add(l4);
			add(l5);
			add(l6);
			add(a4);
			add(a5);
			add(a6);
			add(c1);
			add(c2);
			add(c3);
			pack();
			c2.disable();
		}

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			if(evt.target instanceof TextField)
				return accioCamp((TextField)evt.target);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("Calcular"))
				calcular();
			if(label.equals("Guardar"))
				guardar();
			if(label.equals("Sortir"))
				System.exit(0);
			return true;
		}

		public boolean accioCamp(TextField field) {
			return true;
		}

		public void calcular() {
			Float f1,f2,f3,f4;
			int m,n;

			f1 = Float.valueOf(a1.getText());
			f2 = Float.valueOf(a2.getText());
			f3 = Float.valueOf(a3.getText());
			f4 = Float.valueOf(a4.getText());
			hi = f1.floatValue();
			hx = f2.floatValue();
			v = f3.floatValue();
			dt = f4.floatValue();
			npart = Integer.parseInt(a5.getText());
			max = Integer.parseInt(a6.getText());
			calcul = new Aire1Calculs(hi,hx,v,dt,npart,max);
			if(plot) {
				System.out.println("plot '-' with points");
				for(m=0;m<npart;m++)for(n=0;n<max;n++)
					System.out.println(Double.toString(calcul.trajx[m][n]) + " " + Double.toString(calcul.trajy[m][n]));
				System.out.println("e");
			}
			c2.enable();
		}

		public void guardar() {
			File fitxersortida;		// declaraci d'instncies locals
			FileWriter sortida;
			String linia;
			boolean escriure = true;	// declaraci de variables locals
			int m,n;

			try {
				fitxersortida = demanarFitxer();
				if (fitxersortida != null) {
					escriure = !fitxersortida.exists();
					if (!escriure)
						escriure = demanarConfirmacio();
					if(escriure) {
						sortida = new FileWriter(fitxersortida);
						if(eps) {
							sortida.write("set terminal postscript eps color \n");
							sortida.write("set output '"+nom+".eps' \n");
							sortida.write("plot '-' with points \n");
						}
						for(m=0;m<npart;m++)for(n=0;n<max;n++) {
							linia=Double.toString(calcul.trajx[m][n]) + " " + Double.toString(calcul.trajy[m][n]) + "\n";
							sortida.write(linia);
						}
						if(eps) {
							sortida.write("e \n");
						}
						sortida.close();
					}
				}
			} catch (IOException e){}
		}

		public boolean demanarConfirmacio() {
			Aire1DialegConfirmar confirmar = null ;		// declaraci d'instncies locals
			boolean opcio = false;

			if (confirmar == null)
				confirmar = new Aire1DialegConfirmar(this);
			confirmar.show();
			opcio = confirmar.getOpcio();
			return opcio;
		}

		public File demanarFitxer() {
			FileDialog escollirfitxer = null ;	// declaraci d'instncies locals
			File fitxer;
			String nomdirectori = "./";

			fitxer = new File(nomdirectori,nom);
			try {
				escollirfitxer = new FileDialog(this,"Guardar",escollirfitxer.SAVE);
				escollirfitxer.setFile(nom);
				escollirfitxer.show();
				nom = escollirfitxer.getFile();
				nomdirectori = escollirfitxer.getDirectory();
				fitxer = new File(nomdirectori,nom);
			} catch (NullPointerException e) {
				fitxer = null;
				nom = "sensenom.dat";
			}
			return fitxer;
		}

    		public boolean handleEvent(Event evt) {
        		switch (evt.id) {
				case Event.WINDOW_DESTROY:
					System.exit(0);
        		}
        		return super.handleEvent(evt);
    		}
	}

	class Aire1DialegConfirmar extends Dialog {
		Button c1;
		Button c2;
		Label l1;
		boolean opcio = false;

		Aire1DialegConfirmar(Frame progenitora) {
			super(progenitora,"Confirmar",true);
			setLayout(new GridLayout(0,1,10,10));
			c1 = new Button("D'acord");
			c2 = new Button("Cancel.lar");
			l1 = new Label ("  El fitxer ja existeix. Sobreescriure?");
			add(l1);
			add(c1);
			add(c2);
			pack();
		}

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("D'acord")) {
				opcio = true;
				hide();
			}
			if(label.equals("Cancel.lar")) {
				opcio = false;
				hide();
			}
			return true;
		}

		public boolean getOpcio() {
		return opcio;
		}
	}

class Aire1 {

	public static void main(String args[]) {
		Aire1Gui aire1 = null;		// Declaraci d'instncies.

		aire1 = new Aire1Gui("Aire1");
		for(int i = 0 ; i < args.length ; i++) {
			if(args[i].equals("-p") || args[i].equals("--gnuplot"))
				aire1.plot = true;
			if(args[i].equals("-e") || args[i].equals("--eps"))
				aire1.eps = true;
		}
		aire1.init();
		aire1.show();
	}
}

