import java.awt.*;
import java.lang.*;
import java.io.*;

	class Aire3Gui extends Frame {
		TextField a1,a2,a3,a4,a5;
		Button c1,c2,c3;
		Label l1,l2,l3,l4,l5,l6;
		Aire3Calculs calcul = null ;
		String nom = "sensenom.dat";
		boolean plot = false;
		boolean eps = false;
		int malla = 20;
		float a = 1000.0f;
		float hl = 100.0f;
		float v = 1.0f;
		float sour = 10.0f;

		Aire3Gui(String windowTitle) {
			super(windowTitle);
		}

		public void init() {
			setLayout(new GridLayout(0,2,10,10));
			a1 = new TextField(Integer.toString(malla));
			a2 = new TextField(Float.toString(a));
			a3 = new TextField(Float.toString(hl));
			a4 = new TextField(Float.toString(v));
			a5 = new TextField(Float.toString(sour));
			c1 = new Button("Calcular");
			c2 = new Button("Guardar");
			c3 = new Button("Sortir");
			l1 = new Label("Punts de la malla");
			l2 = new Label("Separacio de la malla (m)");
			l3 = new Label("Alc,ada de la xemeneia (m)");
			l4 = new Label("Velocitat del vent (m/s)");
			l5 = new Label("Intensitat de la font (kg/s)");
			l6 = new Label("");
			add(l1);
			add(a1);
			add(l2);
			add(a2);
			add(l3);
			add(a3);
			add(l4);
			add(a4);
			add(l5);
			add(a5);
			add(c1);
			add(c2);
			add(c3);
			add(l6);
			pack();
			c2.disable();
		}

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			if(evt.target instanceof TextField)
				return accioCamp((TextField)evt.target);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("Calcular"))
				calcular();
			if(label.equals("Guardar"))
				guardar();
			if(label.equals("Sortir"))
				System.exit(0);
			return true;
		}

		public boolean accioCamp(TextField field) {
			return true;
		}

		public void calcular() {
			Float f2,f3,f4,f5;
			int m,n;

			f2 = Float.valueOf(a2.getText());
			f3 = Float.valueOf(a3.getText());
			f4 = Float.valueOf(a4.getText());
			f5 = Float.valueOf(a5.getText());
			malla = Integer.parseInt(a1.getText());
			a = f2.floatValue();
			hl = f3.floatValue();
			v = f4.floatValue();
			sour = f5.floatValue();
			calcul = new Aire3Calculs(malla,a,hl,v,sour);
			if(plot) {
				System.out.println("splot '-' with lines");
				for(m=0;m<malla;m++) {
					for(n=0;n<malla;n++)
						System.out.println(Double.toString(calcul.sol[m][n]));
					System.out.println("");
				}
				System.out.println("e");
			}
			c2.enable();
		}

		public void guardar() {
			File fitxersortida;		// declaraci d'instncies locals
			FileWriter sortida;
			String linia;
			boolean escriure = true;	// declaraci de variables locals
			int m,n;

			try {
				fitxersortida = demanarFitxer();
				if (fitxersortida != null) {
					escriure = !fitxersortida.exists();
					if (!escriure)
						escriure = demanarConfirmacio();
					if(escriure) {
						sortida = new FileWriter(fitxersortida);
						if(eps) {
							sortida.write("set terminal postscript eps color \n");
							sortida.write("set output '"+nom+".eps' \n");
							sortida.write("splot '-' with lines \n");
						}
						for(m=0;m<malla;m++) {
							for(n=0;n<malla;n++)
								sortida.write(Double.toString(calcul.sol[m][n]) + "\n");
							sortida.write("\n");
						}
						if(eps) {
							sortida.write("e \n");
						}
						sortida.close();
					}
				}
			} catch (IOException e){}
		}

		public boolean demanarConfirmacio() {
			Aire3DialegConfirmar confirmar = null ;		// declaraci d'instncies locals
			boolean opcio = false;

			if (confirmar == null)
				confirmar = new Aire3DialegConfirmar(this);
			confirmar.show();
			opcio = confirmar.getOpcio();
			return opcio;
		}

		public File demanarFitxer() {
			FileDialog escollirfitxer = null ;	// declaraci d'instncies locals
			File fitxer;
			String nomdirectori = "./";

			fitxer = new File(nomdirectori,nom);
			try {
				escollirfitxer = new FileDialog(this,"Guardar",escollirfitxer.SAVE);
				escollirfitxer.setFile(nom);
				escollirfitxer.show();
				nom = escollirfitxer.getFile();
				nomdirectori = escollirfitxer.getDirectory();
				fitxer = new File(nomdirectori,nom);
			} catch (NullPointerException e) {
				fitxer = null;
				nom = "sensenom.dat";
			}
			return fitxer;
		}

    		public boolean handleEvent(Event evt) {
        		switch (evt.id) {
				case Event.WINDOW_DESTROY:
					System.exit(0);
        		}
        		return super.handleEvent(evt);
    		}
	}

	class Aire3DialegConfirmar extends Dialog {
		Button c1;
		Button c2;
		Label l1;
		boolean opcio = false;

		Aire3DialegConfirmar(Frame progenitora) {
			super(progenitora,"Confirmar",true);
			setLayout(new GridLayout(0,1,10,10));
			c1 = new Button("D'acord");
			c2 = new Button("Cancel.lar");
			l1 = new Label ("  El fitxer ja existeix. Sobreescriure?");
			add(l1);
			add(c1);
			add(c2);
			pack();
		}

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("D'acord")) {
				opcio = true;
				hide();
			}
			if(label.equals("Cancel.lar")) {
				opcio = false;
				hide();
			}
			return true;
		}

		public boolean getOpcio() {
			return opcio;
		}
	}

class Aire3 {

	public static void main(String args[]) {
		Aire3Gui aire3 = null;		// Declaraci d'instncies.

		aire3 = new Aire3Gui("Aire3");
		for(int i = 0 ; i < args.length ; i++) {
			if(args[i].equals("-p") || args[i].equals("--gnuplot"))
				aire3.plot = true;
			if(args[i].equals("-e") || args[i].equals("--eps"))
				aire3.eps = true;
		}
		aire3.init();
		aire3.show();
	}
}

