import java.lang.*;

/*
-------------------------------------------------------------------------------
"penacho" gaussia
-------------------------------------------------------------------------------
Dades: malla (nombre de punts d'una aresta de la malla), a (distancia entre
       dos dels punts anteriors), hl (alc,ada de la xemeneia), v (velocitat
       del vent), sour (intensitat de la font).
Resultat: fitxer "aire3.dat". Es pot escollir entre diversos formats depenent
          del programa de representacio grafica que s'estigui fent servir.
          El que hi per defecte va be pel GnuPlot.
Dades de prova: malla=20 a=1000 hl=100 v=1 sour=10 ==>
                2.55275e-17
                0.0594194
                59.838
                631.931
                1718.17
                2736.08
                3400.76
                3722.21
                3799.29
                3725.67
                3568.29
                3370.04
                3156.8
                2943.47
                2738.22
                2545.16
                2366
                2201.09
                2050.03
                ......
Observacions: Si no compila be, provar amb l'opcio -lm. La millor instruccio
              per representar-ho es 'splot "aire3.dat" with lines'.
              En aquest cas no n'hi ha prou amb ser coherents amb el sistema
              d'unitats. Les entrades han de ser en SI i llavors la sortida
              es en micrograms per m^3 (que no es SI).
-------------------------------------------------------------------------------
*/

public class Aire3Calculs {
	double a,hl,v,sour,sol[][];
	int malla;

	Aire3Calculs(int malla0,float a0,float hl0,float v0,float sour0) {
		double sigmaz,sigmay,x,y,z,dmy1,dmy2,dmy3;
		int m,n;

		malla = malla0;
		a = (double) a0;
		hl = (double) hl0;
		v = (double) v0;
		sour = (double) sour0;
		sol = new double[malla][malla];

		for(m=0;m<malla;m++) {
			for(n=0;n<malla;n++) {
				x = (double) n+1;
				y = (double) m+1;
				x = x*a;
				y = y*a;
				sigmay=100.0d*Math.pow(x*0.001d,0.9d);
				sigmaz=60.0d*Math.pow(x*0.001d,0.9d);
				dmy1=2.0d*Math.exp(-hl*hl/sigmaz/sigmaz/2.0d);
				dmy2=Math.exp(-y*y/sigmay/sigmay/2.0d);
				dmy3=sour/2.0d/3.14d/v/sigmay/sigmaz;
				z=dmy1*dmy2*dmy3*1.0E9d;
				sol[m][n]=z;
			}
		}
	}
}
